
#include "helper_functions.hpp"
#include <algorithm>
#include <chrono>
#include <ctime>
#include <iostream>
#include <string>
#include <vector>
#include <Rcpp.h>

static unsigned long mean_vector_size = 100000;
static unsigned long search_vector_size = 100000;
static unsigned long matrix_height_a = 1000;
static unsigned long matrix_width_a = 1000;
static unsigned long matrix_height_b = 1000;
static unsigned long matrix_width_b = 1000;

// [[Rcpp::export]]
Rcpp::NumericMatrix cpp_matrix_mul(Rcpp::NumericMatrix a, Rcpp::NumericMatrix b) {
    unsigned long n = a.nrow();    // hoehe a
    unsigned long l = b.ncol(); // breite b
    unsigned long m = a.ncol(); // breite a /hoehe b
    Rcpp::NumericMatrix result(n, b.ncol());
    if (a.ncol() == b.nrow()) {
        for (unsigned long i = 0; i < n; i++)
            for (unsigned long k = 0; k < l; k++)
                for (unsigned long j = 0; j < m; j++) {
                    result(i,j) += a(i,k) * b(k,j);
                }
    } else {
        std::cout << "Error: matricies dont have the right dimensions " << std::endl;
        exit(EXIT_FAILURE);
    }
    return result;
}


// [[Rcpp::export]]
bool cpp_search(std::vector<int> vec) {

    bool missing = false;
    std::vector<bool> vec2(vec.size());

    for (unsigned long i = 0; i < vec.size(); i++) {
        if (std::find(vec.begin(), vec.end(), i) == vec.end()) {
            missing = true;
        };
    }
    return missing;
}

// [[Rcpp::export]]
float cpp_mean(std::vector<int> vec) {

    float result = 0;
    for (unsigned long i = 0; i < vec.size(); i++) {
        result += vec[i];
    }
    return result / vec.size();
}
