#include <vector>
#include <string>
#include <iostream>
#include <chrono>
#include <ctime>
#include <iomanip>

typedef std::vector<std::vector<float>> matrix;

void print_time(std::string str, std::clock_t start, std::clock_t end) {
    std::cout << str << ":" << std::endl
              << std::fixed << std::setprecision(2)
              << "CPU time used: " << 1000.0 * (end - start) / CLOCKS_PER_SEC << "ms\n"
              << "Wall clock time passed: "
              << std::chrono::duration<double, std::milli>(end - start).count() << "ms\n";
}
void print_matrix(matrix a) {
    std::cout << "Matrix:" << std::endl
              << "    Dimensions: " << a.size() << " " << a[0].size() << std::endl;
    for (auto row : a) {
        for (auto entry : row) {
            std::cout << entry << " ";
        }
        std::cout << std::endl;
    }
}


matrix generate_matrix(int rows, int culums) {
    matrix result(rows, std::vector<float>(culums, 0));
    for (int i = 0; i < rows; i++)
        for (int k = 0; k < culums; k++) {
            result[k][i] = i * rows + (1 + k);
        }
    return result;
}
std::vector<int> my_fill(unsigned long num) {
    std::vector<int> vec(num);
    for (unsigned long i = 0; i < num; i++) {
        vec[i] = i;
    }
    return vec;
}
